#!/bin/bash

set_config_value() {
    key="$1"
    new_val="$2"
    header="$3"
    file="$4"
    tmp_file=$(mktemp)
    headerRegex='^\[.+\]'
    targetHeaderRegex="^\[$header\]"
    keyRegex="\s*$key\s*=\s*"
    in_section=""
    IFS=''
    section_found=false
    attribute_found=false
    while read -r line
    do
        if [[ "$line" =~ $headerRegex ]]; then
            if [[ "$line" =~ $targetHeaderRegex ]]; then
                section_found=true
                in_section="1"
            else
                in_section=""
            fi
        fi
        if [[ -n "$in_section" ]]; then
            if [[ "$line" =~ $keyRegex ]]; then
                attribute_found=true
                line="$key = $new_val"
            fi
        fi
        echo "$line" >> "$tmp_file"
    done < "$file"
    if [[ $section_found == false ]]; then
        printf "\n[${header}]\n" >> $tmp_file
    fi
    if [[ $attribute_found == false ]]; then
      sed -i "/${targetHeaderRegex}/a $key = $new_val" $tmp_file
    fi
    mv "$tmp_file" "$file"
}

get_config_value() {
    param_name=$1
    section_name=$2
    config_file=$3
    awk -v section=$section_name -v key=$param_name -F ' *= *' '
    {
        if ($0 ~ /^\[.*\]$/) {
            gsub(/^\[|\]$/, "", $0)
            SECTION=$0
        } else if (($1==key) && (SECTION==section)) {
            print $2
        }
    }
    ' "$config_file"
}
